package com.cardiff.client_project.controller;

import com.cardiff.client_project.mapper.PatientMapper;
import com.cardiff.client_project.service.*;
import com.cardiff.client_project.utils.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;


@Controller
public class ViewController {

    @Autowired
    private SuperAdminService superAdminService;
    @Autowired
    private HospitalService hospitalService;
    @Autowired
    private DeviceService deviceService;
    @Autowired
    private PatientService patientService;
    @Autowired
    private NurseService nurseService;


    @GetMapping("/loadLeft")
    public String loadLeftView() {
        System.out.println("loadLeftView");
        return "leftView";
    }

    @GetMapping("/loadLeft2")
    public String loadLeftView2() {
        return "leftView2";
    }

    @GetMapping("/defaultLoadMain")
    public String loadMainView_1(Model model) {
        Result result = superAdminService.selectAllAdmin();
        // Add data to the model
        model.addAttribute("tableData", result.getData());
        return "mainSupAdminView";
    }

    @GetMapping("/hospitalLoadMain")
    public String loadMainView_2(Model model) {
        //System.out.println("loadMainView_2");
        Result result = superAdminService.selectAllHospital();
        // Add data to the model
        System.out.println("result"+result.getData());
        model.addAttribute("tableData", result.getData());
        // System.out.println("result"+result.getData());
        return "mainHospitalView";
    }

    @GetMapping("/deviceLoadMain/{hospitalId}")
    public String loadMainView_4(Model model, @PathVariable int hospitalId) {
        Result result = deviceService.selectAllDevice(hospitalId);
        System.out.println("result" + result.getData());
        model.addAttribute("tableData", result.getData());
        return "mainDeviceView";
    }

    @GetMapping("/hospitalLoadMain2")
    public String loadMainView_3(Model model) {
        System.out.println("hospitalLoadMain2");
        //System.out.println("loadMainView_2");
        Result result = hospitalService.selectAllHospital();
        // Add data to the model
        System.out.println("result"+result.getData());
        model.addAttribute("tableData", result.getData());
        // System.out.println("result"+result.getData());
        return "mainHospitalView2";
    }

    @GetMapping("/patientLoadMain/{hospitalId}")
    public String loadMainView_5(Model model, @PathVariable int hospitalId) {
        Result result = patientService.selectAllPatient(hospitalId);
        System.out.println("result" + result.getData());
        model.addAttribute("tableData", result.getData());
        return "mainPatientView";
    }

    @GetMapping("/nurseLoadMain/{hospitalId}")
    public String loadMainView_6(Model model, @PathVariable int hospitalId) {
        Result result = nurseService.selectAllNurse(hospitalId);
        System.out.println("result" + result.getData());
        model.addAttribute("tableData", result.getData());
        // System.out.println("result"+result.getData());
        return "mainNurseView";
    }
}
