package com.cardiff.client_project.service.imp;

import com.cardiff.client_project.constant.ResponseCode;
import com.cardiff.client_project.mapper.DeviceMapper;
import com.cardiff.client_project.pojo.entity.Device;
import com.cardiff.client_project.pojo.vo.DeviceVO;
import com.cardiff.client_project.service.DeviceService;
import com.cardiff.client_project.utils.Result;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class DeviceServiceImpl implements DeviceService {
    @Autowired
    private DeviceMapper deviceMapper;

    @Override
    public Result insertDevice(Device device) {
        Result result = deviceMapper.insertDeviceInform(device);
        return result;
    }

    @Override
    public Result deleteById(List<Integer> ids, String type) {
        deviceMapper.deleteByIdAndType(ids,type);
        return Result.success(ResponseCode.SUCCESS);
    }

    @Override
    public Result selectAllDevice(int hospitalId) {
        List<Device> selectVOS = deviceMapper.selectAllDevice(hospitalId);

        List<DeviceVO> deviceVOS = new ArrayList<>();
        selectVOS.forEach(selectVO -> {
            DeviceVO deviceVO = new DeviceVO();
            BeanUtils.copyProperties(selectVO, deviceVO);
            deviceVOS.add(deviceVO);
        });
        return Result.success(deviceVOS);
    }

    @Override
    public Result update(Device device) {
        int update = deviceMapper.update(device);
        if (update > 0) {
            return Result.success(ResponseCode.SUCCESS);
        }
        return Result.error(ResponseCode.ERROR);
    }

    @Override
    public Result selectByItem(Device device) {
        List<Device> selectVos = deviceMapper.selectByItem(device);
        selectVos.forEach(selectVO -> {
            DeviceVO deviceVO = new DeviceVO();
            BeanUtils.copyProperties(selectVO, deviceVO);
        });
        if(!selectVos.isEmpty()){
            return Result.success(selectVos);
        }else {
            return Result.error(ResponseCode.ACCOUNT_NOT_EXISTS);
        }
    }
}
