package com.cardiff.client_project.service.imp;

import com.cardiff.client_project.constant.ResponseCode;
import com.cardiff.client_project.mapper.NurseMapper;
import com.cardiff.client_project.pojo.entity.Nurse;
import com.cardiff.client_project.pojo.vo.NurseVO;
import com.cardiff.client_project.service.NurseService;
import com.cardiff.client_project.utils.Result;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
@Service
public class NurseServiceImp implements NurseService {
    @Autowired
    private NurseMapper nurseMapper;

    @Override
    public Result insertNurse(Nurse nurse) {
        Result result = nurseMapper.insertNurseInform(nurse);
        return result;
    }

    @Override
    public Result deleteById(List<Integer> ids, String type) {
        nurseMapper.deleteByIdAndType(ids,type);
        return Result.success(ResponseCode.SUCCESS);
    }

    @Override
    public Result selectAllNurse(int hospitalId) {
        List<Nurse> selectVOS = nurseMapper.selectAllNurse(hospitalId);

        List<NurseVO> nurseVOS = new ArrayList<>();
        selectVOS.forEach(selectVO -> {
            NurseVO nurseVO = new NurseVO();
            BeanUtils.copyProperties(selectVO, nurseVO);
            // Set the corresponding status string according to status
            if (nurseVO.getStatus() == 1) {
                nurseVO.setStatus_str("ACTIVE");
            }
            if (nurseVO.getStatus() == 0) {
                nurseVO.setStatus_str("INACTIVE");
            }
            nurseVOS.add(nurseVO);
        });
        return Result.success(nurseVOS);
    }

    @Override
    public Result update(Nurse nurse) {
        int update = nurseMapper.update(nurse);
        if (update > 0) {
            return Result.success(ResponseCode.SUCCESS);
        }
        return Result.error(ResponseCode.ERROR);
    }

    @Override
    public Result selectByItem(Nurse nurse) {
        List<Nurse> selectVos = nurseMapper.selectByItem(nurse);
        selectVos.forEach(selectVO -> {
            NurseVO nurseVO = new NurseVO();
            if (selectVO.getStatus() == 1) {
                selectVO.setStatus_str("ACTIVE");
            }
            if (selectVO.getStatus() == 0) {
                selectVO.setStatus_str("INACTIVE");
            }
            BeanUtils.copyProperties(selectVO, nurseVO);
        });
        if(!selectVos.isEmpty()){
            return Result.success(selectVos);
        }else {
            return Result.error(ResponseCode.ACCOUNT_NOT_EXISTS);
        }
    }
}
