package com.cardiff.wylTest;

import com.cardiff.client_project.controller.admin.SuperAdminController;
import com.cardiff.client_project.pojo.vo.AdminVO;
import com.cardiff.client_project.utils.Result;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;


import java.util.List;

import static org.assertj.core.api.Assertions.assertThat;

@SpringBootTest
public class IntegrationFullContainerTest{

    @Autowired
    private SuperAdminController superAdminController;




    @Test
    public void testPageSelectCommonAdmin() {

        Result result1 = superAdminController.pageSelect("commonAdmin", 2, 1);
        assertThat(result1.getCode()).isEqualTo(1);
        List<AdminVO> page1 = (List<AdminVO>) result1.getData();
        assertThat(page1).hasSize(2);
        assertThat(page1.get(0).getName()).isEqualTo("justnoww");


        Result result2 = superAdminController.pageSelect("commonAdmin", 2, 2);
        List<AdminVO> page2 = (List<AdminVO>) result2.getData();
        assertThat(page2).hasSize(1);
        assertThat(page2.get(0).getName()).isEqualTo("cmy");

    }



    @Test
    public void testPageSelectInvalidType() {
        Result result = superAdminController.pageSelect("invalidType", 10, 1);
        assertThat(result.getCode()).isEqualTo(0);
    }

    @Test
    public void testPageSelectInvalidPageNumber() {
        Result result = superAdminController.pageSelect("commonAdmin", 5, 100);
        assertThat(result.getCode()).isEqualTo(0);
        List<AdminVO> data = (List<AdminVO>) result.getData();
        assertThat(data).isNull();
    }
}