package com.cardiff.wylTest;

import com.cardiff.client_project.controller.admin.SuperAdminController;
import com.cardiff.client_project.pojo.dto.SignUserDTO;
import com.cardiff.client_project.service.SuperAdminService;
import com.cardiff.client_project.utils.Result;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.WebMvcTest;
import org.springframework.boot.test.mock.mockito.MockBean;
import org.springframework.http.MediaType;
import org.springframework.security.test.context.support.WithMockUser;
import org.springframework.test.context.junit.jupiter.SpringExtension;
import org.springframework.test.web.servlet.MockMvc;

import java.util.Arrays;
import java.util.List;

import static org.mockito.ArgumentMatchers.any;
import static org.mockito.Mockito.when;
import static org.springframework.security.test.web.servlet.request.SecurityMockMvcRequestPostProcessors.csrf;
import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.*;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.*;

@ExtendWith(SpringExtension.class)
@WebMvcTest(SuperAdminController.class)
public class LightWeightTest_02 {
    @Autowired
    private MockMvc mockMvc;
    @MockBean
    private SuperAdminService superAdminService;
    @Autowired
    private ObjectMapper objectMapper;

    @WithMockUser(username = "2649783657@qq.com",password = "admin")
    @Test
    public void testDeleteAdminById() throws Exception {

        List<Integer> ids = Arrays.asList(1, 2, 3);


        Result mockResult = Result.success("Admins deleted successfully");


        when(superAdminService.deleteById(ids, "commonAdmin")).thenReturn(mockResult);


        mockMvc.perform(delete("/superAdmin/deleteAdminById")
                        .with(csrf())
                        .contentType(MediaType.APPLICATION_JSON)
                        .content(objectMapper.writeValueAsString(ids)))
                .andExpect(status().isOk())
                .andExpect(jsonPath("$.msg").value("Admins deleted successfully"));
    }

}
